﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Runtime.CompilerServices;
using System.Security;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Input;
using Telerik.Windows.Data;
using Telerik.Windows.Controls.Data;
using Telerik.Windows.Controls.Data.PropertyGrid;
using Path = System.IO.Path;

namespace WpfPlayground
{
   /// <summary>
   /// Interaction logic for MainWindow.xaml
   /// </summary>
   public partial class MainWindow : Window, INotifyPropertyChanged
   {
      public MainWindow()
      {
         InitializeComponent();
         DataContext = this;

         Shapes = new Ellipse()
         {
            Center = new Point(1, 1),
            FillColor = Colors.Red,
            RadiusX1 = 4,
            RadiusX2 = 2
         };
      }

      private Ellipse _shape;
      public Ellipse Shapes
      {
         get => _shape;
         set => SetProperty(ref _shape, value);
      }

      private int _counter;
      public int Counter
      {
         get => _counter;
         set => SetProperty(ref _counter, value);
      }

      #region PC

      public event PropertyChangedEventHandler PropertyChanged;

      protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
      {
         PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
      }

      protected virtual void OnPropertyChanged<T>(Expression<Func<T>> raiser)
      {
         var propName = ((MemberExpression)raiser?.Body)?.Member.Name;
         OnPropertyChanged(propName);
      }

      protected bool SetProperty<T>(ref T field, T value, [CallerMemberName] string name = null)
      {
         if (EqualityComparer<T>.Default.Equals(field, value)) return false;
         field = value;
         OnPropertyChanged(name);
         return true;
      }

      #endregion

      private void RadPropertyGrid1_OnFieldLoaded(object sender, FieldEventArgs e)
      {
         ++Counter;
      }
   }

   public class Ellipse : INotifyPropertyChanged
   {
      public Color FillColor { get; set; }

      private double _radiusX1;
      [Telerik.Windows.Controls.Data.PropertyGrid.Editor(typeof(NumericUpDown), "Value")]
      public double RadiusX1
      {
         get => _radiusX1;
         set
         {
            SetProperty(ref _radiusX1, value);
         }
      }

      private double _radiusX2;
      public double RadiusX2
      {
         get => _radiusX2;
         set
         {
            SetProperty(ref _radiusX2, value);
         }
      }

      public Point Center { get; set; }

      #region PC

      public event PropertyChangedEventHandler PropertyChanged;

      protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
      {
         PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
      }

      protected virtual void OnPropertyChanged<T>(Expression<Func<T>> raiser)
      {
         var propName = ((MemberExpression)raiser?.Body)?.Member.Name;
         OnPropertyChanged(propName);
      }

      protected bool SetProperty<T>(ref T field, T value, [CallerMemberName] string name = null)
      {
         if (EqualityComparer<T>.Default.Equals(field, value)) return false;
         field = value;
         OnPropertyChanged(name);
         return true;
      }

      #endregion
   }
}